# Autogenerated wrapper script for NUMA_jll for i686-linux-musl
export libnuma, numastat, numactl

## Global variables
PATH = ""
LIBPATH = ""
LIBPATH_env = "LD_LIBRARY_PATH"

# Relative path to `libnuma`
const libnuma_splitpath = ["lib", "libnuma.so"]

# This will be filled out by __init__() for all products, as it must be done at runtime
libnuma_path = ""

# libnuma-specific global declaration
# This will be filled out by __init__()
libnuma_handle = C_NULL

# This must be `const` so that we can use it with `ccall()`
const libnuma = "libnuma.so.1"


# Relative path to `numastat`
const numastat_splitpath = ["bin", "numastat"]

# This will be filled out by __init__() for all products, as it must be done at runtime
numastat_path = ""

# numastat-specific global declaration
function numastat(f::Function; adjust_PATH::Bool = true, adjust_LIBPATH::Bool = true)
    global PATH, LIBPATH
    env_mapping = Dict{String,String}()
    if adjust_PATH
        if !isempty(get(ENV, "PATH", ""))
            env_mapping["PATH"] = string(PATH, ':', ENV["PATH"])
        else
            env_mapping["PATH"] = PATH
        end
    end
    if adjust_LIBPATH
        if !isempty(get(ENV, LIBPATH_env, ""))
            env_mapping[LIBPATH_env] = string(LIBPATH, ':', ENV[LIBPATH_env])
        else
            env_mapping[LIBPATH_env] = LIBPATH
        end
    end
    withenv(env_mapping...) do
        f(numastat_path)
    end
end


# Relative path to `numactl`
const numactl_splitpath = ["bin", "numactl"]

# This will be filled out by __init__() for all products, as it must be done at runtime
numactl_path = ""

# numactl-specific global declaration
function numactl(f::Function; adjust_PATH::Bool = true, adjust_LIBPATH::Bool = true)
    global PATH, LIBPATH
    env_mapping = Dict{String,String}()
    if adjust_PATH
        if !isempty(get(ENV, "PATH", ""))
            env_mapping["PATH"] = string(PATH, ':', ENV["PATH"])
        else
            env_mapping["PATH"] = PATH
        end
    end
    if adjust_LIBPATH
        if !isempty(get(ENV, LIBPATH_env, ""))
            env_mapping[LIBPATH_env] = string(LIBPATH, ':', ENV[LIBPATH_env])
        else
            env_mapping[LIBPATH_env] = LIBPATH
        end
    end
    withenv(env_mapping...) do
        f(numactl_path)
    end
end


"""
Open all libraries
"""
function __init__()
    global artifact_dir = abspath(artifact"NUMA")

    # Initialize PATH and LIBPATH environment variable listings
    global PATH_list, LIBPATH_list
    # We first need to add to LIBPATH_list the libraries provided by Julia
    append!(LIBPATH_list, [joinpath(Sys.BINDIR, Base.LIBDIR, "julia"), joinpath(Sys.BINDIR, Base.LIBDIR)])
    global libnuma_path = normpath(joinpath(artifact_dir, libnuma_splitpath...))

    # Manually `dlopen()` this right now so that future invocations
    # of `ccall` with its `SONAME` will find this path immediately.
    global libnuma_handle = dlopen(libnuma_path)
    push!(LIBPATH_list, dirname(libnuma_path))

    global numastat_path = normpath(joinpath(artifact_dir, numastat_splitpath...))

    push!(PATH_list, dirname(numastat_path))
    global numactl_path = normpath(joinpath(artifact_dir, numactl_splitpath...))

    push!(PATH_list, dirname(numactl_path))
    # Filter out duplicate and empty entries in our PATH and LIBPATH entries
    filter!(!isempty, unique!(PATH_list))
    filter!(!isempty, unique!(LIBPATH_list))
    global PATH = join(PATH_list, ':')
    global LIBPATH = join(LIBPATH_list, ':')

    # Add each element of LIBPATH to our DL_LOAD_PATH (necessary on platforms
    # that don't honor our "already opened" trick)
    #for lp in LIBPATH_list
    #    push!(DL_LOAD_PATH, lp)
    #end
end  # __init__()

